function varargout = GUI_robot(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_robot_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_robot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before GUI_robot is made visible.
function GUI_robot_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);

% ochrana pi restartu programu
COM_CloseNXT('all'); 

% Spojen s NXT
global h l GPA
h = COM_OpenNXTEx('USB', '0016530BD2E8');
l = COM_OpenNXTEx('USB', '0016530F946B');
L.zakladna = NXTMotor('A');
H.hlavni_rameno = NXTMotor( 'AB');
L.koncove_rameno = NXTMotor( 'B');
H.zapesti = NXTMotor('C');
infoL_kr = L.koncove_rameno.ReadFromNXT();
GPA.skr_Poz = infoL_kr.Position;
infoL_z = L.zakladna.ReadFromNXT();
GPA.scr_Poz = infoL_z.Position;
COM_SetDefaultNXT(h);
infoH_hr = H.hlavni_rameno.ReadFromNXT();
GPA.szr_Poz = infoH_hr.Position;
infoH_z = H.zapesti.ReadFromNXT();
GPA.sz_Poz = infoH_z.Position;
 
% Nastaven vchozch poloh posuvnk
set(handles.slider_celkova_rotace,'Value',GPA.scr_Poz);
set(handles.slider_zvedani_ramene,'Value',GPA.szr_Poz);
set(handles.slider_koncove_rameno,'Value',GPA.skr_Poz);
set(handles.slider_zapesti,'Value',GPA.sz_Poz);


% --- Outputs from this function are returned to the command line.
function varargout = GUI_robot_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in pushbutton_GO.
function pushbutton_GO_Callback(hObject, eventdata, handles)
global GP GPA h l L H
L.zakladna = NXTMotor(       'A', 'Power', GP.scr_P, 'ActionAtTachoLimit', 'Coast', 'TachoLimit', GP.scr_L);
H.hlavni_rameno = NXTMotor( 'AB', 'Power', GP.szr_P, 'ActionAtTachoLimit', 'Coast', 'TachoLimit', GP.szr_L);
L.koncove_rameno = NXTMotor( 'B', 'Power', GP.skr_P, 'ActionAtTachoLimit', 'HoldBrake', 'TachoLimit', GP.skr_L);
H.zapesti = NXTMotor(        'C', 'Power', GP.sz_P, 'ActionAtTachoLimit', 'Coast', 'TachoLimit', GP.sz_L);
L.uchop=0;
% vodn fze pohybu
COM_SetDefaultNXT(l);
L.zakladna.SendToNXT();
COM_SetDefaultNXT(h);
H.hlavni_rameno.SendToNXT();
H.hlavni_rameno.WaitFor();
% prostedn fze pohybu
H.zapesti.SendToNXT();
COM_SetDefaultNXT(l);
L.koncove_rameno.SendToNXT();
L.koncove_rameno.WaitFor();
% konen fze
L.uchop.SendToNXT();
L.uchop.WaitFor();

% zskn novho vchozho bodu, odkud se rameno bude pohybovat
infoL_kr = L.koncove_rameno.ReadFromNXT();
GPA.skr_Poz = infoL_kr.Position;
infoL_z = L.zakladna.ReadFromNXT();
GPA.scr_Poz = infoL_z.Position;
COM_SetDefaultNXT(h);
infoH_hr = H.hlavni_rameno.ReadFromNXT();
GPA.szr_Poz = infoH_hr.Position;
infoH_z = H.zapesti.ReadFromNXT();
GPA.sz_Poz = infoH_z.Position;

% Nastaven pesnch poloh posuvnk:
set(handles.slider_celkova_rotace,'Value',GPA.scr_Poz);
set(handles.slider_zvedani_ramene,'Value',GPA.szr_Poz);
set(handles.slider_koncove_rameno,'Value',GPA.skr_Poz);
set(handles.slider_zapesti,'Value',GPA.sz_Poz);

% zobrazen graf
X(1)=0;
X(2)=sind(180/765*GPA.scr_Poz)*cosd(75/1000*GPA.szr_Poz);
X(3)=X(2)+sind(180/765*GPA.scr_Poz)*cosd(-180+75/1000*GPA.szr_Poz+GPA.skr_Poz+5)*.85;

Y(1)=0; % Vertikla
Y(2)=sind(75/1000*GPA.szr_Poz);
Y(3)=Y(2)-sind(75/1000*GPA.szr_Poz+GPA.skr_Poz)*.85;

Z(1)=1; % Hloubka Y
Z(2)=Z(1)+sind(180/765*GPA.scr_Poz-90);
Z(3)=Z(2)+sind(180/765*GPA.scr_Poz-90)*.85;

axes(handles.AX_rameno);
plot3(X,Z,Y);
CamPos=[6.360702972558032,-7.069079100042573,7.488376526466564];
CamTag=[1,0.5,1];
DataAspR=[2,1,2];
ZL=[0,2];
XL=[0,2];
YL=[-2,2];
set(handles.AX_rameno,'CameraPosition',CamPos,'CameraTarget',CamTag,'DataAspectRatio',...
    DataAspR,'XGrid','ON','YGrid','ON','ZGrid','ON','Xlim',XL,'YLim',YL,'ZLim',ZL);

X1(1)=1;
X1(2)=1-sind(180/765*GPA.scr_Poz-90);
Y1(1)=0;
Y1(2)=sind(180/765*GPA.scr_Poz)*cosd(75/1000*GPA.szr_Poz);
axes(handles.AX_zakladna);
plot(X1,Y1,'r');
set(handles.AX_zakladna,'Xlim',XL,'YLim',YL,'ZLim',ZL);



% --- Executes on button press in pushbutton_RP.
function pushbutton_RP_Callback(hObject, eventdata, handles)
global RP0 GP
RP0=GP;


% --- Executes on slider movement.
function slider_celkova_rotace_Callback(hObject, eventdata, handles)
 global GP RP0
 
 scr_pos_OK=(0:45:765);
 scr_pos=double(get(hObject,'Value'));
 for i=(1:1:(length(scr_pos_OK)))
     if(scr_pos<scr_pos_OK(i))
         if scr_pos<(scr_pos_OK(i)-22.5)
             GP.scr_pos_set=scr_pos_OK(i-1);
         else
             GP.scr_pos_set=(scr_pos_OK(i));
         end%if2
         break
     end%if1
 end%for
 set(handles.slider_celkova_rotace,'Value',GP.scr_pos_set);
 GP.scr_L=abs(RP0.scr_pos_set-GP.scr_pos_set); % vzdlenost, kterou mus rameno urazit
if(RP0.scr_pos_set<GP.scr_pos_set)
    GP.scr_P=15; %oten ->
else
    GP.scr_P=-15; %oten <-
end

% --- Executes during object creation, after setting all properties.
function slider_celkova_rotace_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function slider_zvedani_ramene_Callback(hObject, eventdata, handles)
global GP RP0
 
 szr_pos_OK=(0:200:1000);
 szr_pos=double(get(hObject,'Value'));
 for i=(1:1:(length(szr_pos_OK)))
     if(szr_pos<szr_pos_OK(i))
         if szr_pos<(szr_pos_OK(i)-100)
             GP.szr_pos_set=szr_pos_OK(i-1);
         else
             GP.szr_pos_set=(szr_pos_OK(i));
         end%if2
         break
     end%if1
 end%for
 set(handles.slider_zvedani_ramene,'Value',GP.szr_pos_set);
 GP.szr_L=abs(RP0.szr_pos_set-GP.szr_pos_set); % vzdlenost, kterou mus rameno urazit
if(RP0.szr_pos_set<GP.szr_pos_set)
    GP.szr_P=100; %pohyb nahoru
else
    GP.szr_P=-50; %pohyb dolu
end


% --- Executes during object creation, after setting all properties.
function slider_zvedani_ramene_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function slider_koncove_rameno_Callback(hObject, eventdata, handles)
% hObject    handle to slider_koncove_rameno (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global GP RP0
 
 skr_pos_OK=(0:10:90);
 skr_pos=double(get(hObject,'Value'));
 for i=(1:1:(length(skr_pos_OK)))
     if(skr_pos<skr_pos_OK(i))
         if skr_pos<(skr_pos_OK(i)-5)
             GP.skr_pos_set=skr_pos_OK(i-1);
         else
             GP.skr_pos_set=(skr_pos_OK(i));
         end%if2
         break
     end%if1
 end%for
 set(handles.slider_koncove_rameno,'Value',GP.skr_pos_set);
 GP.skr_L=abs(RP0.skr_pos_set-GP.skr_pos_set); % vzdlenost, kterou mus rameno urazit
if(RP0.skr_pos_set<GP.skr_pos_set)
    GP.skr_P=-50; %pohyb nahoru
else
    GP.skr_P=10; %pohyb dolu
end

% --- Executes during object creation, after setting all properties.
function slider_koncove_rameno_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function slider_zapesti_Callback(hObject, eventdata, handles)
% hObject    handle to slider_zapesti (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global GP RP0
 
 sz_pos_OK=(0:30:330);
 sz_pos=double(get(hObject,'Value'));
 for i=(1:1:(length(sz_pos_OK)))
     if(sz_pos<-15)                       % pokud je sz men jak 0, posune posuvnk doprava na 330
         GP.sz_pos_set=330;
         break
     elseif(sz_pos>345)                   % pokud je vt ne 345, posune posuvnk doleva na 0
         GP.sz_pos_set=0;
         break
     elseif(sz_pos<sz_pos_OK(i))
         if sz_pos<(sz_pos_OK(i)-15)
             GP.sz_pos_set=sz_pos_OK(i-1);
         else
             GP.sz_pos_set=(sz_pos_OK(i));
         end%if2
         break
     end%if1
 end%for
 set(handles.slider_zapesti,'Value',GP.sz_pos_set);
 GP.sz_L=abs(RP0.sz_pos_set-GP.sz_pos_set); % vzdlenost, kterou mus rameno urazit
if(RP0.sz_pos_set<GP.sz_pos_set)
    GP.sz_P=-40; %pohyb ->
else
    GP.sz_P=40; %pohyb <-
end

% --- Executes during object creation, after setting all properties.
function slider_zapesti_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
